#include <stdio.h>
#include <math.h>
#define  ncol     1024
#define  nrow     1024
#define  NN        ncol*nrow
#define  nint(a)  (((a)<0.)?(int)((a)-0.5):(int)((a)+0.5))
#define  abs(a)   (((a)<0.)? -(a): (a))
#define  MAXSKY    10000     // maxbox  5~11
#define  MINSKY    20
#define  DELSKY    2000      // use 4/5 of CCD frame status sky
#define  maxstar   50000
#define  NOPT      12
#define  MAXAP     3

FILE     *fp,*fp1;
char     head[36][80], b[99],ff[80], f2[30],color;      
short    map[NN], bias[NN], flat[NN];
int      nstar, ringin= 10,  ringou= 20;
float    tt[NN],  a_b[nrow][ncol];         
float    par[MAXAP]={3,4,5}, opt[NOPT],sky[MAXSKY];
float    lobad,hibad,phpadu,readns,rinsq,routsq,apmxsq;
float    skymod,skymode,hmin;
double   apmag[3], area[3], magerr[3];

void  quick_sort();
void  mmm();
int   phot();
float skyy();

main(ac,av)
int ac; char *av[];
{
  int i,j,k,ip=1;
  float *pp;
  float bmag,berr,xcen,ycen,bsky,bsg;

  if(ac<2){ printf("\n\t** processing cstar_data  (Sextract+DAO_ap) ******\n");
            printf("\n\tUsage: sap 1*  (or A*.fit)   2012,3,2\n\n");
            exit(0);
  }
  fp=fopen("/vega2/rhbin/cstarpip2.par","r");
  if(fp==0){ printf("cstarpip2.par not found!\n"); exit(0); }
  for(i=0;i<NOPT;i++){
l9: fgets(ff,80,fp);   if(ff[0]=='*')goto l9;
    sscanf(&ff[29],"%f",&opt[i]);
  } fclose(fp);

  strcpy(f2,"/vega2/rhbin/1bias.fit");
  fp=fopen(f2,"rb"); if(fp==0){ printf("%s not found!\n",f2); exit(0); }
  fseek(fp,36*80,0); fread(bias,2,NN,fp); fclose(fp); swap2(bias,2*NN);
  strcpy(f2,"/vega2/rhbin/1flat.fit");
  fp=fopen(f2,"rb"); if(fp==0){ printf("%s not found!\n",f2); exit(0); }
  fseek(fp,36*80,0); fread(flat,2,NN,fp); fclose(fp); swap2(flat,2*NN);

  system("cp /vega2/rhbin/cefault.sex default.sex");
  system("cp /vega2/rhbin/cefault.param default.param");
  system("cp /vega2/rhbin/default.conv .");
  system("cp /vega2/rhbin/default.nnw .");

  readns=opt[0];
  phpadu=opt[1];
  hibad =opt[3];

  for(k=1;k<ac;k++){
    strcpy(ff,av[k]);
    j=strlen(ff); for(i=0;i<j;i++)if(ff[i]=='.')break;
    if(i==j) strcat(ff,".fit");
    if(ff[9]!='f' || ff[10]!='i' || ff[11]!='t')continue;
    fp=fopen(ff,"rb"); if(fp==0)continue;
    printf("%d: %s ",ip++,ff); color=ff[0];
    fread(head,36,80,fp);  sscanf(&head[1][26],"%d",&i);
    if(i!=16){ fclose(fp); printf("not a cstar file!\n"); continue; }
    fread(map,2,NN,fp); fclose(fp); swap2(map,2*NN);

    if(color=='A')for(i=0;i<NN;i++)tt[i]=map[i]+32768;
    if(color=='1'){
      ff[0]=color='A';
      for(i=0;i<NN;i++)tt[i]=map[i]-bias[i];             // -bias;
      for(i=0;i<NN;i++)tt[i]/=flat[i]/10000.;           //  /flat*10000
      for(i=0;i<NN;i++)map[i]=tt[i]-32768;
      fp=fopen(ff,"wb"); swap2(map,2*NN);
      fwrite(head,36,80,fp); fwrite(map,2,NN,fp); fclose(fp);
    }
    if(color !='A'){ printf("not a cstar file!\n"); continue; }
    pp=(float*)a_b; for(i=0;i<NN;i++)*pp++=tt[i];

    skymod=skyy(opt[0],hibad);
//    hmin = skymod;  if(skymod<0.)hmin=0;
//    hmin = sqrt(readns*readns + hmin/phpadu);
//    lobad = 0.1*nint(10.*(skymod-opt[2]*hmin));
    lobad=skymod*0.5;
    apmxsq=par[MAXAP-1]+0.5;  apmxsq*=apmxsq; 
    rinsq=ringin*ringin;                       
    routsq = (float)MAXSKY/3.1416 + rinsq;  routsq = ringou*ringou;

    sprintf(b,"sex %s",ff);  system(b);
    ff[9]='s'; ff[10]='a'; ff[11]='p'; 
    fp1=fopen(ff,"w");
    for(j=11;j<15;j++)head[j][29]=0;  head[10][30]=0;
    sprintf(b,"#Temp: %sc %s%s Exp:%s Filt: %c",&head[10][27],&head[11][17],
      &head[12][17],&head[13][25],head[14][28]);
    fprintf(fp1,"%s\n",b);
    fprintf(fp1,"#         X       Y       ap=3         ap=4         ap=5          bertin      sky  FLAG S/G\n");
    fprintf(fp1,"#------------------------------------------------------------------------------------------\n");
//------
  nstar=0;
  fp=fopen("test.cat","r");
l10:
  fgets(b,99,fp); if(feof(fp))goto l20;
  if(b[0]=='#')goto l10;
  sscanf(b,"%d %f %f %f %f %f %d %f",&i,&bmag,&berr,&xcen,&ycen,&bsky,&j,&bsg);
  sscanf(&b[29],"%f %f",&xcen,&ycen);
  if(phot(xcen,ycen)){ nstar++;
    fprintf(fp1,"%5d%8.2f%8.2f%7.3lf%6.3lf%7.3lf%6.3lf%7.3lf%6.3lf %7.3f%6.3f%9.2f%3d%5.2f\n",
    i,xcen,ycen,apmag[0],magerr[0],apmag[1],magerr[1],apmag[2],magerr[2],bmag,berr,bsky,j,bsg);
  }   
  goto l10;
l20:
  fclose(fp);
  printf(" %d\n",nstar);
//-----
    fclose(fp1);
  }
}

float skyy(readns, hibad)
float readns, hibad;
{
  float skymn, skymed, skymod, skysig, skyskw;
  int   istep, irow, i, j, n, ifirst;

  istep  = ncol*nrow/MAXSKY+1;
  ifirst =  n = 0;
  for(irow=0;irow<nrow;irow++){
    for(j=0;j<ncol;j++)tt[j]=a_b[irow][j];
    ifirst++;    if (ifirst > istep) ifirst -= istep;
    i = ifirst-1;
    while(i<ncol)if(abs(tt[i]) <= hibad) {
      sky[n++] = tt[i];
      if (n == MAXSKY)break;
      i+=istep;
    } else i++;
  }
  n-=DELSKY;                // use 4/5 ccd frame status sky
  if(n<1000)return(65000.);
  quick_sort(sky, n);
  mmm(sky,&n, hibad, readns,&skymn,&skymed,&skymod,&skysig,&skyskw);
  skymode=skymod;
  return(skymod);
}

void mmm(sky,dnsky,hibad,readns, dskymn,dskymed,dskymod,dsigma,dskew)
float sky[];
int   *dnsky;
float hibad, readns;
float *dskymn,*dskymed,*dskymod,*dsigma,*dskew;
{
  double sum,sumsq;
  float  skymn, skymed, skymod, sigma;
  float  cut,cut1,cut2,delta,skymid,r,center,side,dmod,old,clamp;
  int    i,j,k,l,m,minimm,maximm,niter,istep,maxit,jstep,nsky;
  char   redo;

  nsky=*dnsky;
  maxit=30;                      // itet times
  if(nsky <= 0)goto l9900;
  skymid=0.5*(sky[(nsky-1)/2]+sky[nsky/2]);
  sum=0.;
  sumsq=0.;
  cut1=skymid-sky[0];
  if(cut1> sky[nsky-1]-skymid)cut1=sky[nsky-1]-skymid;
  if(cut1> hibad-skymid)cut1=hibad-skymid;
  cut2=skymid + cut1;
  cut1=skymid - cut1;
  minimm=0;
  for(i=1;i<=nsky;i++){                // 1010
    if(sky[i-1] < cut1){ minimm=i; continue; }
    if(sky[i-1] > cut2)goto l1020;
    delta=sky[i-1]-skymid;
    sum+=delta;
    sumsq+=delta*delta;
    maximm=i;
  }
l1020:
  skymed=0.5*(sky[(minimm+maximm-1)/2]+sky[(minimm+maximm)/2]);
  skymn=sum/(maximm-minimm);
  sigma=sqrt(sumsq/(maximm-minimm)-skymn*skymn);
  skymn+=skymid;
  skymod=skymn;
  if(skymed < skymn) skymod=3.*skymed-2.*skymn;

  niter= 0;
  old  = 0.;
  clamp= 1.;
l2000:
  niter++;
  if( (niter > maxit) || (maximm-minimm < MINSKY)) goto l9900;
  r=log10((float)(maximm-minimm));
  r= (-.1042*r+1.1695)*r+.8895;
  if(r<2.)r=2.;
  cut= r*sigma+0.5*abs(skymn-skymod);
  if(cut<1.5)cut=1.5;
  cut1=skymod-cut;
  cut2=skymod+cut;
  redo=0;
  istep=1; if(cut1-sky[minimm]<0.)istep=-1;
  jstep=(istep+1)/2;
  if (istep > 0)goto  l2120;
l2100:
  if ((istep < 0) && (minimm <= 0))goto  l2150;
  if((sky[minimm-1] <= cut1) && (sky[minimm] >= cut1))goto l2150;
l2120:
  delta=sky[minimm+jstep-1]-skymid;
  sum-=istep*delta;
  sumsq-=istep*delta*delta;
  minimm+=istep;
  redo=1;
  goto l2100;
l2150:
  istep=1; if(cut2-sky[maximm-1]<0.)istep=-1;
  jstep=(istep+1)/2;
  if(istep < 0)goto  l2220;
l2200:
  if((istep > 0) && (maximm >= nsky))goto l2250;
  if((sky[maximm-1] <= cut2) && (sky[maximm] >= cut2))goto l2250;
l2220:
  delta=sky[maximm+jstep-1]-skymid;
  sum+=istep*delta;
  sumsq+=istep*delta*delta;
  maximm+=istep;
  redo=1;
  goto l2200;
l2250:
  skymn=sum/(maximm-minimm);
  sigma=sqrt(sumsq/(maximm-minimm)-skymn*skymn);
  skymn+=skymid;
  skymed=0.;
  center = (minimm+1 + maximm)/2.;
  j= nint(0.2*(maximm-minimm));
  side = j/2. + 0.25;
  j = nint(center-side);
  k = nint(center+side);
  l = nint(center-0.25);
  m = nint(center+0.25);
  r = 0.25*readns;
l2305:
  if((j>1)&&(k<nsky)&&((sky[l-1]-sky[j-1]<r)||(sky[k-1]-sky[m-1]<r))){
    j--;    k++;    goto l2305;
  }
  for(i=j;i<=k;i++) skymed+=sky[i-1];
  skymed/=(k-j+1);
  if(skymed < skymn) dmod=3.*skymed-2.*skymn - skymod;
  else dmod=skymn - skymod;
  if (dmod*old < 0.) clamp = 0.5*clamp;
  skymod += clamp*dmod;
  old = dmod ;
  if (redo)goto  l2000;
  if(sigma<1.)sigma=1.;
  *dskew=(skymn-skymod)/sigma;
  *dnsky=maximm-minimm;
  *dskymn=skymn;
  *dskymed=skymed;
  *dskymod=skymod;
  *dsigma=sigma;
  return;
l9900:
  *dsigma=-1.0;
  *dskew=0.0;
  return;
}

int phot(xc,yc)
float xc,yc;
{
  float  skymod, skysig, skyskw, datum, fractn, edge;
  float  rsq, dysq, sigsq, err1, err2, err3, dum;
  int    i, j, k, lx, ly, mx, my, nsky;

  lx = (xc-ringou)+1; if(lx<1)lx=1;
  mx = xc+ringou;     if(mx>ncol)mx=ncol;
  ly = (yc-ringou)+1; if(ly<1)ly=1;
  my = yc+ringou;     if(my>nrow)my=nrow;
                        edge=xc-0.5;
  if(edge>ncol-(xc-0.5))edge=ncol-(xc-0.5);
  if(edge>yc-0.5)       edge=yc-0.5;
  if(edge>nrow-(yc-0.5))edge=nrow-(yc-0.5);
  for(i=0;i<MAXAP;i++){
    apmag[i] = area[i]=0.;
    if (edge < par[i]) apmag[i]=-1.1e30;          // null magnitude
  }
  nsky=0;
  for(j=ly;j<=my;j++){          // 2130
    dysq=j-yc; dysq*=dysq;
    for(i=lx;i<=mx;i++){        // 2125
      rsq=dysq+(i-xc)*(i-xc);
      datum=a_b[j-1][i-1];
      if( (rsq<rinsq) || (rsq > routsq) || (nsky>=MAXSKY) )goto l2110;
      if  (datum > hibad)goto l2110;
      if  (datum < lobad)goto l2110;
      sky[nsky++]=datum;
l2110:
      if( rsq > apmxsq)continue;
      dum=sqrt(rsq)-0.5;
      for(k=0;k<MAXAP;k++){      // 2120
        if( dum > par[k])continue;
        fractn=par[k]-dum;
        if(fractn>1.)fractn=1.;   if(fractn<0.)fractn=0.;
        if ((datum >= lobad) && (datum <= hibad) && (apmag[k] > -1.0e20)) {
//      if ( (datum <= hibad) && (apmag[k] > -1.0e20)) {
          apmag[k]+=fractn*datum;  area[k]+=fractn;
        } else {
          if (datum > hibad) apmag[k] = -1.1e38;
          else apmag[k] = -1.0e30;
        }
      }                               // 2120
    }                                 // 2125
  }                                   // 2130
  if( nsky < MINSKY){
    for(i=0;i<MAXAP;i++){ apmag[i] = 99.999; magerr[i] = 9.999; }
    goto l2221;
  }

  quick_sort(sky,nsky);
  mmm(sky,&nsky,hibad,readns,&dum,&datum,&skymod,&skysig,&skyskw);

  dum=skysig*skysig;
  sigsq=dum/(float)nsky;
  for(i=0;i<MAXAP;i++){           // 2220
    if( apmag[i] < -1.e31) { apmag[i] = 99.999;  magerr[i] = 9.999; continue; }
    if( skysig < -0.5)goto l2210;
    apmag[i]-=skymod*area[i];
    if (apmag[i] <=0.)goto l2210;
    err1=area[i]*dum;
    err2=apmag[i]/phpadu;
    err3=sigsq*area[i]*area[i];
    magerr[i]=1.0857*sqrt(err1+err2+err3)/apmag[i];
    if(magerr[i]>9.999)magerr[i]=9.999;
    apmag[i]=25.-2.5*log10(apmag[i]);
    if( apmag[i] > 94.999)goto l2210;
    continue;
l2210:
    apmag[i]=94.999;    magerr[i]=9.999;
  }                             // 2220
l2221:
  if(apmag[0]<50. && magerr[0]<5.)return (1); else return (0);
}

quick_sort(a,n)
float *a; int n;
{
  int i,j,k=2,ii,ifin;
  float x;
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(a[i]<=a[j])continue;
    x = a[j];
l40:
    a[j]= a[i];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(a[i]>x)goto l40;
l60:
    a[j]=x;
  }
  if(k>1)goto l20;
}
